#!/usr/bin/env node

const path = require('path');
const fs = require('fs');

const args = require('minimist')(process.argv.slice(2));


if (process.argv.slice(2).length === 0) {
    const repl = require('repl');
    repl.start();
    require('./src/register')();
} else {
    const CWD = process.cwd();
    const cwdModulesPath = path.resolve(CWD, 'node_modules');

    const requireFilePaths = args['_'].map(function checkFileExist(f) {
        try {
            const filePath = require.resolve(f, {
                paths: [CWD, cwdModulesPath]
            });

            if (!fs.existsSync(filePath)) {
                throw Error(`Cannot find module${filePath}`);
            }
            return filePath;
        } catch (err) {
            throw err;
        }

    })
    require('./src/register')();
    requireFilePaths.map(function requireFiles(f) {
        require(f);
    });
}