const babelCodeFram = require('babel-code-frame');
const getRawCode = require('./getRawCode');
const chalk = require('chalk')

const DEFAULT_CONFIG = {
  highlightCode: true,
  linesAbove: 2,
  linesBelow: 3,
  showFilePath:true,//额外的
};
module.exports = function getCodeFrame(filePath,lNum,cNum=0,opts={}) {
  const content = getRawCode(filePath);
  if(typeof cNum ==="object"){
      opts = cNum;
      cNum=0;
  }
  const config = { ...DEFAULT_CONFIG, ...opts };
  const codeFrame = babelCodeFram(content, +lNum, +cNum, config);
  if (config.showFilePath) {
    return chalk.bgMagenta.whiteBright(`${filePath}:${lNum}:${cNum}`) + '\n' + codeFrame;
  }
  return codeFrame;
};