const path=require('path');
const fs=require('fs');
const debug = require('./debugPlus')('getRawCode');
const chalk = require('chalk');


/**
 * 从缓存中获取文件内容(如果有的话)
 */
const sourceFileCache = {};
module.exports = function getRawCode(filePath) {
  if (filePath in sourceFileCache) {
    debug('#cache hit:', chalk.green(filePath));
    return sourceFileCache[filePath];
  }
  return (sourceFileCache[filePath] = fs.readFileSync(filePath, {
    encoding: 'utf-8'
  }));
}
module.exports.sourceFileCache = sourceFileCache;