const debug= require('./debugPlus')('getConfig');

module.exports = function getConfig(configObj, keyPath, def, allowFunVal=false) {
  if (typeof configObj === 'object' && configObj) {
    let configVal;
    if (Array.isArray(keyPath)) {
      configVal = keyPath.reduce(function(last, key) {
        if (typeof last === 'object' && key in last) {
          return last[key];
        }
        return undefined;
      }, configObj);
    } else {
      configVal = configObj[keyPath];
    }
    if (!allowFunVal && typeof configVal === 'function') {
      debug(`"${keyPath}" is function.`);
      const val = configVal(def);
      debug(`return:`, val);
      return val;
    } else {
      return typeof configVal === 'undefined' ? def : configVal;
    }
  }
  return def;
};
