const genModuleResolverConfig = require('./genModuleResolverConfig');
const esModToCommon = require('./esModToCommon');
const prettyError = require('./prettyError');
const mapSourcePosition = require('./mapSourcePosition');
const getRawCode = require('./getRawCode');
const getUserConfig = require('./getUserConfig');
const getHelpfulFrame = require('./getHelpfulFrame');
const getCodeFrame = require('./getCodeFrame');
const openEditor = require('./openEditor');
const mockFilePath = require('./mockFilePath');
const retrieveFilePath = require('./retrieveFilePath');
const repairSourceMap = require('./repairSourceMap');
const repairStackFilename = require('./repairStackFilename');

const funs = {
  esModToCommon,
  mapSourcePosition,
  prettyError,
  genModuleResolverConfig,
  getRawCode,
  getUserConfig,
  getHelpfulFrame,
  getCodeFrame,
  openEditor,
  mockFilePath,
  retrieveFilePath,
  repairSourceMap,
  repairStackFilename,
};
const exFunList = ['mockFilePath', 'retrieveFilePath', 'repairSourceMap', 'repairStackFilename'];

function makeTools(contextConfig) {
    return exFunList.reduce(function(obj, keyname) {
      obj[keyname] = funs[keyname].bind(null, contextConfig);
      return obj;
    }, Object.create(funs));
}

module.exports = Object.assign(makeTools, funs, { make: makeTools });