const sourceMapSupport = require('source-map-support');

const HEADER_LENGTH = 62; //https://github.com/evanw/node-source-map-support/blob/master/source-map-support.js#L338:9

function getNum(p1, msgKey) {
  if (typeof p1 === 'number' || typeof p1 === 'string') {
    p1 = parseInt(p1);
    if (p1 >= 0) {
      return p1;
    }
    throw RangeError(`${msgKey} must be greater than or equal to 0`);
  }
  throw TypeError(`${msgKey} must be a number. `);
}

/**
 * 基于sourceMapSupport.mapSourcePosition方法，对参数进行整数转换和位置修正
 * 参考:wrapCallSite {@link https://github.com/evanw/node-source-map-support/blob/master/source-map-support.js#L323}
 *
 */
module.exports = function mapSourcePosition(position) {
  position.line = getNum(position.line, 'line');
  position.column = getNum(position.column, 'column');
  if (position.line === 1 && position.column >= HEADER_LENGTH) {
    position.column -= HEADER_LENGTH;
  }
  const pos = sourceMapSupport.mapSourcePosition(position);
  pos.column += 1; //这里+1是参考 https://github.com/evanw/node-source-map-support/blob/master/source-map-support.js#L351

  return pos;
};
