const prettyError = require('pretty-error');
const DEFAULT_STYLE = {
  'pretty-error': {
    marginLeft: 0
  },
  'pretty-error > trace': {
    marginLeft: 2
  },
  'pretty-error > trace > item': {
    display: 'block',
    marginBottom: 1,
    marginLeft: 2,
    bullet: '"<bright-cyan>o</bright-cyan>"'
  },
  'pretty-error > trace > item > header > pointer > file': {
    color: 'bright-cyan'
  },
  'pretty-error > trace > item > header > pointer > line': {
    color: 'bright-cyan'
  },
  'pretty-error > trace > item > header > what': {
    color: 'bright-white'
  }
};
let pe = null;
module.exports = function (opts = {}) {
  const {
    skipNodeFiles,
    skipPackage,
    style,
    alias
  } = opts;
  pe = pe || prettyError.start();
  pe.skipNodeFiles(...[].concat(skipNodeFiles));
  pe.skipPackage(...[].concat(skipPackage));
  pe.appendStyle(style);

  alias.forEach(function (val) {
    if (Array.isArray(val) && typeof val[0] === 'string' && typeof val[1] === 'string') {
      pe.alias(val[0].replace(/\\/g, '/'), val[1]);
    }
  });
};
module.exports.DEFAULT_STYLE = DEFAULT_STYLE;