const debug = require('./debugPlus')('retrieveFilePath');
const path = require('path');

/**
 * 还原"伪造"的文件路径
 */
module.exports = function retrieveFilePath(opts,fakePath) {
  const { sourceMapRootPathAlias, rootPath, rootPathAlias } = opts;
  let originalPath;
  if (/node_module/.test(fakePath)) {
    originalPath = fakePath.replace(sourceMapRootPathAlias, rootPath);
  } else {
    originalPath = fakePath.replace(rootPathAlias, rootPath).replace(/\.(\w+)\s*(?:\[from (.+)\])?$/, function(matchStr, p1, p2) {
      if (p2) {
        return `.${p2}`;
      } else {
        return `.${p1}`;
      }
    });
  }
  return originalPath.replace(/[/]/g, path.sep);
}
